class RedState
   def next
       GreenState.new
   end
   def light
       'red'
   end
end

class YellowState
   def next
       RedState.new
   end
   def light
       'yellow'
   end
end

class GreenState
   def next
       YellowState.new
   end
   def light
       'green'
   end
end

signal = RedState.new

puts signal.light()
signal = signal.next()
puts signal.light()
signal = signal.next()
puts signal.light()
signal = signal.next()
puts signal.light()

